app/apps/patients/urls.py
from django.urls import path

from django_filters.views import FilterView
from .models import Patient
from .views import PatientView, PatientDetail, PatientCreate, PatientDelete
from .views import PatientAutocomplete

app_name = 'patients'

urlpatterns = [
    path('', PatientView.as_view(), name='patient.list'),
    path('list/', FilterView.as_view(model=Patient), name='patient.filter.list'),
    path('create/', PatientCreate.as_view(), name='patient.create'),
    path('<uuid:pk>/', PatientDetail.as_view(), name='patient.detail'),
    path('<uuid:pk>/update/', PatientCreate.as_view(), name='patient.update'),
    path('<uuid:pk>/delete/', PatientDelete.as_view(), name='patient.delete'),
    path('patient-autocomplete/', PatientAutocomplete.as_view(), name='patient.autocomplete'),
]

app/config/urls.py
from django.conf import settings
from django.conf.urls.static import static

from django.contrib import admin
from django.urls import path, include
from django.views.decorators.csrf import csrf_exempt
from graphene_django.views import GraphQLView
from django.shortcuts import render


urlpatterns = [
    # Django admin
    path('admin/', admin.site.urls),
    # Django front-end
    path('', include('dashboard.urls')),
    path('reports/', include('reports.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
    path('persons/', include('persons.urls')),
    path('patients/', include('patients.urls')),
    path('hospitals/', include('hospitals.urls')),
    path('travels/', include('travels.urls')),
    # API
    path('api/v1/', include('api.rest.v1.urls')),
    path('graphql/', csrf_exempt(GraphQLView.as_view(graphiql=True))),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/apps/patients/models.py
from django.db import models
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _
from django.contrib.auth import get_user_model

# Create your models here.

from utils.models import BaseModel, DateModel
from persons.models import Person
from hospitals.models import Hospital
from locations.models import Region


class Patient(DateModel):
    person = models.OneToOneField(
        to=Person,
        on_delete=models.PROTECT,
        related_name='patient',
        verbose_name=_('patients.patient.person'),
        null=True
    )
    hospital = models.ForeignKey(
        to=Hospital,
        on_delete=models.SET_NULL,
        related_name='patients',
        blank=True,
        null=True,
        verbose_name=_('patients.patient.hospital')
    )
    region = models.ForeignKey(
        to=Region,
        on_delete=models.SET_NULL,
        related_name='patients',
        blank=True,
        null=True,
        verbose_name=_('patients.patient.region')
    )
    contacted = models.ManyToManyField(
        to='self',
        blank=True,
        verbose_name=_('patients.patient.contacted')  
    )
    create_by = models.ForeignKey(
        to=get_user_model(),
        on_delete=models.SET_NULL,
        related_name='patients',
        blank=True,
        null=True,
        verbose_name=_('patients.patient.create_by')
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('patients.patient.verbose')
        verbose_name_plural = _('patients.patient.plural')
        permissions = [
            ('self_region', "Editing your region"),
            ('self_patient', "Editing your patient"),
        ]

    def __str__(self) -> str:
        return f'{self.person.iin} - {self.person.full_name}'

    def get_absolute_url(self):
        return reverse('patients:patient.detail', kwargs={'pk': self.pk})


class PatientStatus(DateModel):
    class MethodInfectionChoices(models.IntegerChoices):
        sample = 0, _('patients.method_infection_choices.sample')

    class CaseChoices(models.IntegerChoices):
        local = 0, _('patients.case_choices.local')
        imported = 1, _('patients.case_choices.imported')
        contact = 2, _('patients.case_choices.contact')

    class EntryChoices(models.IntegerChoices):
        sample = 0, _('patients.entry_choices.sample')

    class InfectionChoices(models.IntegerChoices):
        infected = 1, _('patients.infection_choices.infected')
        contact = 2, _('patients.infection_choices.contact')
        potential = 3, _('patients.infection_choices.potential')

    class HospitalizationChoices(models.IntegerChoices):
        home = 0, _('patients.hospitalization_choices.home')
        hospitalized = 1, _('patients.hospitalization_choices.hospitalized')

    class StatusChoices(models.IntegerChoices):
        dead = 0, _('patients.status_choices.dead')
        alive = 1, _('patients.status_choices.alive')

    patient = models.OneToOneField(
        to=Patient,
        on_delete=models.CASCADE,
        related_name='status',
        verbose_name=_('patients.patient_status.patient')
    )
    method_infection = models.IntegerField(
        choices=MethodInfectionChoices.choices,
        blank=True,
        null=True,
        verbose_name=_('patients.patient_status.method_infection')
    )
    type_case = models.IntegerField(
        choices=CaseChoices.choices,
        blank=True,
        null=True,
        verbose_name=_('patients.patient_status.type_case')
    )
    type_entry = models.IntegerField(
        choices=EntryChoices.choices,
        blank=True,
        null=True,
        verbose_name=_('patients.patient_status.type_entry')
    )
    type_infection = models.IntegerField(
        choices=InfectionChoices.choices,
        blank=True,
        null=True,
        verbose_name=_('patients.patient_status.type_infection')
    )
    type_hospitalization = models.IntegerField(
        choices=HospitalizationChoices.choices,
        blank=True,
        null=True,
        verbose_name=_('patients.patient_status.type_hospitalization')
    )
    type_status = models.IntegerField(
        choices=StatusChoices.choices,
        blank=True,
        null=True,
        verbose_name=_('patients.patient_status.type_status')
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('patients.patient_status.verbose')
        verbose_name_plural = _('patients.patient_status.plural')

    def __str__(self) -> str:
        return str(self.patient)


class State(DateModel):
    name = models.CharField(
        max_length=256,
        verbose_name=_('patients.state.name')
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('patients.state.verbose')
        verbose_name_plural = _('patients.state.plural')

    def __str__(self) -> str:
        return str(self.name)


class PatientState(DateModel):
    patient = models.ForeignKey(
        to=Patient,
        on_delete=models.CASCADE,
        related_name='states',
        verbose_name=_('patients.patient_state.patient')
    )
    state = models.ForeignKey(
        to=State,
        on_delete=models.PROTECT,
        related_name='patients',
        null=True,
        verbose_name=_('patients.patient_state.state')
    )
    comment = models.TextField(
        blank=True,
        verbose_name=_('patients.patient_state.comment')
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('patients.patient_state.verbose')
        verbose_name_plural = _('patients.patient_state.plural')

    def __str__(self) -> str:
        return str(self.state)

app/apps/persons/models.py
from django.db import models
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _
from django.utils import timezone

# Create your models here.

from utils.models import BaseModel, DateModel
from locations.models import Country, Address
from jobs.models import Job

from utils.image import upload_photo


class Person(DateModel):
    class GenderChoices(models.IntegerChoices):
        FEMALE = 0, _('persons.gender_choices.female')
        MALE = 1, _('persons.gender_choices.male')

    iin = models.CharField(
        max_length=12,
        unique=True,
        blank=True,
        null=True,
        verbose_name=_('persons.person.iin')
    )
    passport = models.CharField(
        max_length=32,
        unique=True,
        blank=True,
        null=True,
        verbose_name=_('persons.person.passport')
    )
    first_name = models.CharField(
        max_length=256,
        verbose_name=_('persons.person.first_name')
    )
    last_name = models.CharField(
        max_length=256,
        verbose_name=_('persons.person.last_name')
    )
    middle_name = models.CharField(
        max_length=256,
        blank=True,
        verbose_name=_('persons.person.middle_name')
    )
    gender = models.IntegerField(
        choices=GenderChoices.choices,
        default=0,
        verbose_name=_('persons.person.gender')
    )
    birth_date = models.DateField(
        null=True,
        verbose_name=_('persons.person.birth_date')
    )
    image = models.ImageField(
        default='persons/profile/default.png',
        upload_to=upload_photo,
        verbose_name=_('persons.person.image'),
        blank=True
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('persons.person.verbose')
        verbose_name_plural = _('persons.person.plural')
    
    def __str__(self) -> str:
        return str(self.iin) if self.iin else str(self.passport)

    @property
    def full_name(self) -> str:
        return f'{self.last_name} {self.first_name} {self.middle_name}'.strip()

    @property
    def age(self):
        if not self.birth_date:
            return 0
        result = timezone.localdate() - self.birth_date
        return int(result.days / 365.2425)

    def get_absolute_url(self):
        return reverse('person_detail', kwargs={'pk': self.pk})


class PersonContact(DateModel):
    class ContactChoices(models.IntegerChoices):
        phone = 0, _('persons.contact_choices.phone')
        email = 1, _('persons.contact_choices.email')

    person = models.ForeignKey(
        to=Person,
        on_delete=models.CASCADE,
        related_name='contacts',
        verbose_name=_('persons.person_contact.person')
    )
    kind = models.IntegerField(
        choices=ContactChoices.choices,
        verbose_name=_('persons.person_contact.kind')
    )
    value = models.CharField(
        max_length=64,
        verbose_name=_('persons.person_contact.value')
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('persons.person_contact.verbose')
        verbose_name_plural = _('persons.person_contact.plural')
        constraints = [
            models.UniqueConstraint(fields=['person', 'value'], name='person_contact_unique') 
        ]

    def __str__(self) -> str:
        return str(self.person)


class PersonExtra(DateModel):
    person = models.OneToOneField(
        to=Person,
        on_delete=models.CASCADE,
        related_name='extras',
        verbose_name=_('persons.person_extra.person')
    )
    address = models.ForeignKey(
        to=Address,
        on_delete=models.SET_NULL,
        related_name='persons',
        blank=True,
        null=True,
        verbose_name=_('persons.person_extra.address')
    )
    job = models.ForeignKey(
        Job,
        on_delete=models.SET_NULL,
        related_name='persons',
        null=True,
        blank=True,
        verbose_name=_('persons.person_extra.job')
    )
    citizenship = models.ForeignKey(
        to=Country,
        on_delete=models.SET_NULL,
        related_name='persons',
        blank=True,
        null=True,
        verbose_name=_('persons.person_extra.citizenship')
    )

    class Meta:
        ordering = ('created_at', )
        verbose_name = _('persons.person_extra.verbose')
        verbose_name_plural = _('persons.person_extra.plural')

    def __str__(self) -> str:
        return str(self.person)

app/api/rest/v1/patients/views.py
from django_filters import rest_framework as filters
from rest_framework import filters as drf_filters
from rest_framework import viewsets
from rest_framework.response import Response
from django.shortcuts import get_object_or_404
from django.db.models import Q

from rest_framework.permissions import IsAuthenticated
from rest_access_policy import AccessPolicy

from .serializers import StateSerializer, PatientSerializer, PatientCreateSerializer, PatientStatusSerializer, PatientStateSerializer
from patients.models import State, Patient, PatientStatus, PatientState


class PatientAccessPolicy(AccessPolicy):
    statements = [
        {
            "action": [
                "list",
                "list_status",
                "create",
                "retrieve",
                "update",
                "partial_update",
                "destroy",
            ],
            "principal": [
                "group:admin",
                "group:moder",
            ],
            "effect": "allow"
        }, {
            "action": [
                "list",
                "retrieve",
            ],
            "principal": [
                "group:check",
            ],
            "effect": "allow"
        }
    ]


class StateView(viewsets.ModelViewSet):
    serializer_class = StateSerializer
    queryset = State.objects.all()
    permission_classes = [IsAuthenticated, PatientAccessPolicy]
    filter_backends = [filters.DjangoFilterBackend]


class PatientCreateView(viewsets.ModelViewSet):
    serializer_class = PatientCreateSerializer
    queryset = Patient.objects.all()
    permission_classes = [IsAuthenticated, PatientAccessPolicy]
    filter_backends = [drf_filters.SearchFilter, filters.DjangoFilterBackend]

    def create(self, request):
        try:
            serializer = self.get_serializer(data=request.data)
            if serializer.is_valid(raise_exception=True):
                serializer.save(create_by=request.user)
            headers = self.get_success_headers(serializer.data)
            return Response(serializer.data, status=201, headers=headers)
        except Exception as e:
            return Response({'error': str(e)})


class PatientView(viewsets.ModelViewSet):
    serializer_class = PatientSerializer
    queryset = Patient.objects.all()
    permission_classes = [IsAuthenticated, PatientAccessPolicy]
    filter_backends = [drf_filters.SearchFilter, filters.DjangoFilterBackend]
    filterset_fields = {
        'person__iin': ['exact'],
        'person__last_name': ['exact', 'iexact'],
        'person__first_name': ['exact', 'iexact'],
        'person__middle_name': ['exact', 'iexact'],
        'region': ['exact'],
        'status__method_infection': ['exact'],
        'status__type_case': ['exact'],
        'status__type_entry': ['exact'],
        'status__type_infection': ['exact'],
        'status__type_hospitalization': ['exact'],
        'status__type_status': ['exact'],
    }
    search_fields = ['person__iin', 'person__last_name', 'person__first_name', 'person__middle_name']

    def get_queryset(self):
        user = self.request.user
        if user.has_perm('patients.self_region') and not user.is_superuser:
            return self.queryset.filter(Q(region=user.region) | Q(create_by=user))
        if user.has_perm('patients.self_patient') and not user.is_superuser:
            return self.queryset.filter(create_by=user)
        return self.queryset


class PatientStatusView(viewsets.ModelViewSet):
    serializer_class = PatientStatusSerializer
    queryset = PatientStatus.objects.all()
    permission_classes = [IsAuthenticated, PatientAccessPolicy]
    filter_backends = [filters.DjangoFilterBackend]

    def retrieve(self, request, pk=None):
        status = get_object_or_404(self.queryset, patient__pk=pk)
        serializer = self.serializer_class(status)
        return Response(serializer.data)

    def list_status(self, request):
        def to_dict(choices):
            return dict((k, i) for k, i in choices)
        item = PatientStatus()
        result = {
            'method_infection': to_dict(item.MethodInfectionChoices.choices),
            'type_case': to_dict(item.CaseChoices.choices),
            'type_entry': to_dict(item.EntryChoices.choices),
            'type_infection': to_dict(item.InfectionChoices.choices),
            'type_hospitalization': to_dict(item.HospitalizationChoices.choices),
            'type_status': to_dict(item.StatusChoices.choices),
        }
        return Response(result, status=200)


class PatientStateView(viewsets.ModelViewSet):
    serializer_class = PatientStateSerializer
    queryset = PatientState.objects.all()
    permission_classes = [IsAuthenticated, PatientAccessPolicy]
    filter_backends = [filters.DjangoFilterBackend]

    def create(self, request, pk=None):
        try:
            patient = Patient.objects.get(pk=pk)
            serializer = self.serializer_class(data=request.data)
            if serializer.is_valid(raise_exception=True):
                serializer.save(patient=patient)
            headers = self.get_success_headers(serializer.data)
            return Response(serializer.data, status=201, headers=headers)
        except Exception as e:
            return Response({'error': str(e)})

    def retrieve(self, request, pk=None, state=None):
        try:
            queryset = self.queryset.filter(patient=pk)
            state = get_object_or_404(queryset, uuid=state)
            serializer = self.serializer_class(state)
            return Response(serializer.data)
        except Exception as e:
            return Response({'error': str(e)})

app/templates/patients/patient_detail.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Пациент: {{ object.person.full_name }}{% endblock title %}

{% block main %}
<div class="wrapper">
    {% include 'sidebar.html' %}
    <div id="content-page" class="content-page">
        {% include 'navbar.html' %}
        <div class="container-fluid">
            <div class="row">
                <div class="col-lg-4">
                    <div class="iq-card">
                        <div class="iq-card-body pl-0 pr-0 pt-0">
                            <div class="doctor-details-block">
                            <div class="doc-profile-bg bg-primary" style="height:150px;">
                            </div>
                            <div class="doctor-profile text-center">
                                <img src="{{ object.person.image.url }}" style="object-fit: cover; border-radius: 50%;" alt="profile-img" class="avatar-130 img-fluid">
                            </div>
                            <div class="text-center mt-3 pl-3 pr-3">
                                <h4><b>{{ object.person.full_name }}</b></h4>
                            </div>
                            <hr>
                            <ul class="doctoe-sedual d-flex align-items-center justify-content-between p-0 m-0">
                                <li class="text-center">
                                    <h3 class="counter">{{ object.contacted.count }}</h3>
                                    <span>Зарегистрированных контактов</span>
                                </li>
                            </ul>
                            </div>
                        </div>
                    </div>
                    <div class="iq-card">
                        <div class="iq-card-header d-flex justify-content-between">
                            <div class="iq-header-title">
                            <h4 class="card-title">Персональные данные</h4>
                            </div>
                        </div>
                        <div class="iq-card-body">
                            <div class="about-info m-0 p-0">
                            <div class="row">
                                <div class="col-4">ИИН:</div>
                                <div class="col-8">{{ object.person.iin }}</div>
                                <div class="col-4">Паспорт:</div>
                                <div class="col-8">{{ object.person.passport }}</div>
                                <div class="col-4">Имя:</div>
                                <div class="col-8">{{ object.person.first_name }}</div>
                                <div class="col-4">Фамилия:</div>
                                <div class="col-8">{{ object.person.last_name }}</div>
                                <div class="col-4">Отчетство:</div>
                                <div class="col-8">{{ object.person.middle_name }}</div>
                                <div class="col-4">Пол:</div>
                                <div class="col-8">{{ object.person.get_gender_display }}</div>
                                <div class="col-4">Возраст:</div>
                                <div class="col-8">{{ object.person.age }}</div>
                                <div class="col-4">Эл. почта:</div>
                                <div class="col-8">
                                    {% for contact in object.person.contacts.all %}
                                        {% if contact.kind == 1 %}
                                            <span>{{ contact.value }}</span><br>
                                        {% endif %}
                                    {% endfor %}
                                </div>
                                <div class="col-4">Телефон:</div>
                                <div class="col-8">
                                    {% for contact in object.person.contacts.all %}
                                        {% if contact.kind == 0 %}
                                            <span>{{ contact.value }}</span><br>
                                        {% endif %}
                                    {% endfor %}
                                </div>
                                <div class="col-4">Локация:</div>
                                <div class="col-8">{{ object.person.extras.address.city }}</div>
                            </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-lg-8">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="iq-card">
                            <div class="iq-card-header d-flex justify-content-between">
                                <div class="iq-header-title">
                                    <h4 class="card-title">Статус пациента</h4>
                                </div>
                            </div>
                            <div class="iq-card-body">
                                <ul class="speciality-list m-0 p-0">
                                    <li class="d-flex mb-4 align-items-center">
                                        <div class="user-img img-fluid"><a href="#" class="iq-bg-primary"><i class="ri-award-fill"></i></a></div>
                                        <div class="media-support-info ml-3">
                                            <p class="mb-0">Способ заражения</p>
                                            <h6>{{ object.status.get_method_infection_display }}</h6>
                                        </div>
                                    </li>
                                    <li class="d-flex mb-4 align-items-center">
                                        <div class="user-img img-fluid"><a href="#" class="iq-bg-primary"><i class="ri-award-fill"></i></a></div>
                                        <div class="media-support-info ml-3">
                                            <p class="mb-0">Тип случая</p>
                                            <h6>{{ object.status.get_type_case_display }}</h6>
                                        </div>
                                    </li>
                                    <li class="d-flex mb-4 align-items-center">
                                        <div class="user-img img-fluid"><a href="#" class="iq-bg-primary"><i class="ri-award-fill"></i></a></div>
                                        <div class="media-support-info ml-3">
                                            <p class="mb-0">Тип въезда</p>
                                            <h6>{{ object.status.get_type_entry_display }}</h6>
                                        </div>
                                    </li>
                                    <li class="d-flex mb-4 align-items-center">
                                        <div class="user-img img-fluid"><a href="#" class="iq-bg-primary"><i class="ri-award-fill"></i></a></div>
                                        <div class="media-support-info ml-3">
                                            <p class="mb-0">Статус инфецирования</p>
                                            <h6>{{ object.status.get_type_infection_display }}</h6>
                                        </div>
                                    </li>
                                    <li class="d-flex mb-4 align-items-center">
                                        <div class="user-img img-fluid"><a href="#" class="iq-bg-primary"><i class="ri-award-fill"></i></a></div>
                                        <div class="media-support-info ml-3">
                                            <p class="mb-0">Статус госпитализации</p>
                                            <h6>{{ object.status.get_type_hospitalization_display }}</h6>
                                        </div>
                                    </li>
                                    <li class="d-flex mb-4 align-items-center">
                                        <div class="user-img img-fluid"><a href="#" class="iq-bg-primary"><i class="ri-award-fill"></i></a></div>
                                        <div class="media-support-info ml-3">
                                            <p class="mb-0">Текущее состяние</p>
                                            <h6>{{ object.status.get_type_status_display }}</h6>
                                        </div>
                                    </li>
                                </ul>
                            </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="iq-card">
                            <div class="iq-card-header d-flex justify-content-between">
                                <div class="iq-header-title">
                                    <h4 class="card-title">Состояния пациента</h4>
                                </div>
                            </div>
                            <div class="iq-card-body">
                                <ul class="list-inline m-0 p-0">
                                    {% for state in object.states.all %}
                                    <li>
                                        <h6 class="float-left mb-1">{{ state }}</h6>
                                        <small class="float-right mt-1">{{ state.created_at }}</small>
                                        <div class="d-inline-block w-100">
                                            <p>{{ state.comment }}</p>
                                        </div>
                                    </li>
                                    {% empty %}
                                    <li>
                                        <h6 class="float-left mb-1">Отсутствуют</h6>
                                        <small class="float-right mt-1">-</small>
                                        <div class="d-inline-block w-100"></div>
                                    </li>
                                    {% endfor %}
                                </ul>
                            </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="iq-card">
                            <div class="iq-card-header d-flex justify-content-between">
                                <div class="iq-header-title">
                                    <h4 class="card-title">Рейсы</h4>
                                </div>
                            </div>
                            <div class="iq-card-body">
                                <ul class="iq-timeline">
                                    {% for flight in object.flights.all %}
                                    <li>
                                        <div class="timeline-dots border-primary"></div>
                                        <h6 class="">{{ flight.arrival }}</h6>
                                        <small class="mt-1">{{ flight.date_at }}</small>
                                    </li>
                                    {% empty %}
                                    <li>
                                        <div class="timeline-dots border-info"></div>
                                        <h6 class="">Отсутствуют</h6>
                                        <small class="mt-1">-</small>
                                    </li>
                                    {% endfor %}
                                </ul>
                            </div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <div class="iq-card">
                            <div class="iq-card-header d-flex justify-content-between">
                                <div class="iq-header-title">
                                    <h4 class="card-title">Контакты</h4>
                                </div>
                            </div>
                            <div class="iq-card-body">
                                <table class="table mb-0 table-borderless">
                                <thead>
                                    <tr>
                                        <th scope="col">ФИО</th>
                                        <th scope="col">ИИН</th>
                                        <th scope="col">Паспорт</th>
                                        <th scope="col">Пол</th>
                                        <th scope="col">Дата рождения</th>
                                        <th scope="col">Возраст</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    {% for contact in object.contacted.all %}
                                    <tr>
                                        <td><a href="{{ contact.get_absolute_url }}">{{ contact.person.full_name }}</a></td>
                                        <td>{{ contact.person.iin }}</td>
                                        <td>{{ contact.person.passport }}</td>
                                        <td>{{ contact.person.get_gender_display }}</td>
                                        <td>{{ contact.person.birth_date }}</td>
                                        <td>{{ contact.person.age }}</td>
                                    </tr>
                                    {% endfor %}
                                </tbody>
                            </table>
                            </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        {% include 'footer.html' %}
    </div>
</div>
{% endblock main %}